package com.example.onlineshop.service;

import org.springframework.stereotype.Service;

import com.example.onlineshop.models.Category;
import com.example.onlineshop.models.Size;
import com.example.onlineshop.repository.CategoryRepository;
import com.example.onlineshop.repository.SizeRepository;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DataInit {
    private final CategoryRepository categoryRepository;
    private final SizeRepository sizeRepository;

    public DataInit(CategoryRepository categoryRepository, SizeRepository sizeRepository) {
        this.categoryRepository = categoryRepository;
        this.sizeRepository = sizeRepository;
    }

    public void initData() {
        if (categoryRepository.count() == 0) {
            String[] categoryArray = {"Футболки", "Шорты", "Штаны", "Кроссовки", "Куртки"};
            
            for (String category : categoryArray){
                Category tmpCategory = new Category();
                tmpCategory.setName(category);
                categoryRepository.save(tmpCategory);
            }
        }

        if (sizeRepository.count() == 0){
            String[] sizeArray = {"S", "M", "L", "XS", "XL"};
            
            for (String size : sizeArray){
                Size tmpSize = new Size();
                tmpSize.setName(size);
                sizeRepository.save(tmpSize);
            }
        }
    }
}
